
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class StudentsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const students = await db.students.create(
            {
                id: data.id || undefined,
        
        student_number: data.student_number
        ||
        null
            ,
            
        first_name: data.first_name
        ||
        null
            ,
            
        last_name: data.last_name
        ||
        null
            ,
            
        gender: data.gender
        ||
        null
            ,
            
        date_of_birth: data.date_of_birth
        ||
        null
            ,
            
        enrollment_date: data.enrollment_date
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        email: data.email
        ||
        null
            ,
            
        phone: data.phone
        ||
        null
            ,
            
        address: data.address
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await students.setOrganization(currentUser.organization.id || null, {
            transaction,
        });
        
        await students.setCampus( data.campus || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.students.getTableName(),
                belongsToColumn: 'photo',
                belongsToId: students.id,
            },
            data.photo,
            options,
        );
        

        return students;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const studentsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                student_number: item.student_number
            ||
            null
            ,
            
                first_name: item.first_name
            ||
            null
            ,
            
                last_name: item.last_name
            ||
            null
            ,
            
                gender: item.gender
            ||
            null
            ,
            
                date_of_birth: item.date_of_birth
            ||
            null
            ,
            
                enrollment_date: item.enrollment_date
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                email: item.email
            ||
            null
            ,
            
                phone: item.phone
            ||
            null
            ,
            
                address: item.address
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const students = await db.students.bulkCreate(studentsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < students.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.students.getTableName(),
                    belongsToColumn: 'photo',
                    belongsToId: students[i].id,
                },
                data[i].photo,
                options,
            );
        }
        

        return students;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const students = await db.students.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.student_number !== undefined) updatePayload.student_number = data.student_number;
        
        
        if (data.first_name !== undefined) updatePayload.first_name = data.first_name;
        
        
        if (data.last_name !== undefined) updatePayload.last_name = data.last_name;
        
        
        if (data.gender !== undefined) updatePayload.gender = data.gender;
        
        
        if (data.date_of_birth !== undefined) updatePayload.date_of_birth = data.date_of_birth;
        
        
        if (data.enrollment_date !== undefined) updatePayload.enrollment_date = data.enrollment_date;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.email !== undefined) updatePayload.email = data.email;
        
        
        if (data.phone !== undefined) updatePayload.phone = data.phone;
        
        
        if (data.address !== undefined) updatePayload.address = data.address;
        
        
        updatePayload.updatedById = currentUser.id;

        await students.update(updatePayload, {transaction});

        
        
        if (data.organization !== undefined) {
            await students.setOrganization(
              
              (globalAccess ? data.organization : currentUser.organization.id),
              
              { transaction }
            );
        }
        
        if (data.campus !== undefined) {
            await students.setCampus(
              
              data.campus,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.students.getTableName(),
                belongsToColumn: 'photo',
                belongsToId: students.id,
            },
            data.photo,
            options,
        );
        

        return students;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const students = await db.students.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of students) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of students) {
                await record.destroy({transaction});
            }
        });


        return students;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const students = await db.students.findByPk(id, options);

        await students.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await students.destroy({
            transaction
        });

        return students;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const students = await db.students.findOne(
            { where },
            { transaction },
        );

        if (!students) {
            return students;
        }

        const output = students.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        output.guardians_student = await students.getGuardians_student({
            transaction
        });
        
        
        
        
        output.class_enrollments_student = await students.getClass_enrollments_student({
            transaction
        });
        
        
        
        
        
        
        output.attendance_records_student = await students.getAttendance_records_student({
            transaction
        });
        
        
        
        output.invoices_student = await students.getInvoices_student({
            transaction
        });
        
        
        
        
        output.assessment_results_student = await students.getAssessment_results_student({
            transaction
        });
        
        
        
        
        
        
        output.organization = await students.getOrganization({
            transaction
        });
        
        
        output.campus = await students.getCampus({
            transaction
        });
        
        
        output.photo = await students.getPhoto({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.organizations,
        as: 'organization',
        
      },

      {
        model: db.campuses,
        as: 'campus',
        
        where: filter.campus ? {
          [Op.or]: [
            { id: { [Op.in]: filter.campus.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.campus.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



      {
        model: db.file,
        as: 'photo',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.student_number) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'students',
                        'student_number',
                        filter.student_number,
                    ),
                };
            }
            
            if (filter.first_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'students',
                        'first_name',
                        filter.first_name,
                    ),
                };
            }
            
            if (filter.last_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'students',
                        'last_name',
                        filter.last_name,
                    ),
                };
            }
            
            if (filter.email) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'students',
                        'email',
                        filter.email,
                    ),
                };
            }
            
            if (filter.phone) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'students',
                        'phone',
                        filter.phone,
                    ),
                };
            }
            
            if (filter.address) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'students',
                        'address',
                        filter.address,
                    ),
                };
            }
            

            
            

            
            if (filter.date_of_birthRange) {
                const [start, end] = filter.date_of_birthRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    date_of_birth: {
                    ...where.date_of_birth,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    date_of_birth: {
                    ...where.date_of_birth,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.enrollment_dateRange) {
                const [start, end] = filter.enrollment_dateRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    enrollment_date: {
                    ...where.enrollment_date,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    enrollment_date: {
                    ...where.enrollment_date,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.gender) {
                where = {
                    ...where,
                gender: filter.gender,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      
      if (filter.organization) {
        const listItems = filter.organization.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationId: {[Op.or]: listItems}
        };
      }
      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.students.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'students',
                        'student_number',
                        query,
                    ),
                ],
            };
        }

        const records = await db.students.findAll({
            attributes: [ 'id', 'student_number' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['student_number', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.student_number,
        }));
    }

    
};

